diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/load.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/load.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/load.php	2013-07-08 07:59:10.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/load.php	2013-09-16 13:30:10.000000000 -0500
***************
*** 370,375 ****
--- 370,393 ----
  }
  
  /**
+  * Access/Modify private global variable $_wp_using_ext_object_cache
+  *
+  * Toggle $_wp_using_ext_object_cache on and off without directly touching global
+  *
+  * @since 3.7.0
+  *
+  * @param bool $using Whether external object cache is being used
+  * @return bool The current 'using' setting
+  */
+ function wp_using_ext_object_cache( $using = null ) {
+ 	global $_wp_using_ext_object_cache;
+ 	$current_using = $_wp_using_ext_object_cache;
+ 	if ( null !== $using )
+ 		$_wp_using_ext_object_cache = $using;
+ 	return $current_using;
+ }
+ 
+ /**
   * Starts the WordPress object cache.
   *
   * If an object-cache.php file exists in the wp-content directory,
***************
*** 379,409 ****
   * @since 3.0.0
   */
  function wp_start_object_cache() {
! 	global $_wp_using_ext_object_cache, $blog_id;
  
  	$first_init = false;
   	if ( ! function_exists( 'wp_cache_init' ) ) {
  		if ( file_exists( WP_CONTENT_DIR . '/object-cache.php' ) ) {
  			require_once ( WP_CONTENT_DIR . '/object-cache.php' );
! 			$_wp_using_ext_object_cache = true;
! 		} else {
! 			require_once ( ABSPATH . WPINC . '/cache.php' );
! 			$_wp_using_ext_object_cache = false;
  		}
  		$first_init = true;
! 	} else if ( !$_wp_using_ext_object_cache && file_exists( WP_CONTENT_DIR . '/object-cache.php' ) ) {
  		// Sometimes advanced-cache.php can load object-cache.php before it is loaded here.
  		// This breaks the function_exists check above and can result in $_wp_using_ext_object_cache
  		// being set incorrectly. Double check if an external cache exists.
! 		$_wp_using_ext_object_cache = true;
  	}
  
  	// If cache supports reset, reset instead of init if already initialized.
  	// Reset signals to the cache that global IDs have changed and it may need to update keys
  	// and cleanup caches.
  	if ( ! $first_init && function_exists( 'wp_cache_switch_to_blog' ) )
  		wp_cache_switch_to_blog( $blog_id );
! 	else
  		wp_cache_init();
  
  	if ( function_exists( 'wp_cache_add_global_groups' ) ) {
--- 397,429 ----
   * @since 3.0.0
   */
  function wp_start_object_cache() {
! 	global $blog_id;
  
  	$first_init = false;
   	if ( ! function_exists( 'wp_cache_init' ) ) {
  		if ( file_exists( WP_CONTENT_DIR . '/object-cache.php' ) ) {
  			require_once ( WP_CONTENT_DIR . '/object-cache.php' );
! 			if ( function_exists( 'wp_cache_init' ) )
! 				wp_using_ext_object_cache( true );
  		}
+ 
  		$first_init = true;
! 	} else if ( ! wp_using_ext_object_cache() && file_exists( WP_CONTENT_DIR . '/object-cache.php' ) ) {
  		// Sometimes advanced-cache.php can load object-cache.php before it is loaded here.
  		// This breaks the function_exists check above and can result in $_wp_using_ext_object_cache
  		// being set incorrectly. Double check if an external cache exists.
! 		wp_using_ext_object_cache( true );
  	}
  
+ 	if ( ! wp_using_ext_object_cache() )
+ 		require_once ( ABSPATH . WPINC . '/cache.php' );
+ 
  	// If cache supports reset, reset instead of init if already initialized.
  	// Reset signals to the cache that global IDs have changed and it may need to update keys
  	// and cleanup caches.
  	if ( ! $first_init && function_exists( 'wp_cache_switch_to_blog' ) )
  		wp_cache_switch_to_blog( $blog_id );
! 	elseif ( function_exists( 'wp_cache_init' ) )
  		wp_cache_init();
  
  	if ( function_exists( 'wp_cache_add_global_groups' ) ) {
***************
*** 425,436 ****
  		if ( ! is_blog_installed() && ! defined( 'WP_INSTALLING' ) )
  			wp_die( __( 'The site you have requested is not installed properly. Please contact the system administrator.' ) );
  	} elseif ( ! is_blog_installed() && false === strpos( $_SERVER['PHP_SELF'], 'install.php' ) && !defined( 'WP_INSTALLING' ) ) {
- 
- 		$link = wp_guess_url() . '/wp-admin/install.php';
- 
  		require( ABSPATH . WPINC . '/kses.php' );
  		require( ABSPATH . WPINC . '/pluggable.php' );
  		require( ABSPATH . WPINC . '/formatting.php' );
  		wp_redirect( $link );
  		die();
  	}
--- 445,456 ----
  		if ( ! is_blog_installed() && ! defined( 'WP_INSTALLING' ) )
  			wp_die( __( 'The site you have requested is not installed properly. Please contact the system administrator.' ) );
  	} elseif ( ! is_blog_installed() && false === strpos( $_SERVER['PHP_SELF'], 'install.php' ) && !defined( 'WP_INSTALLING' ) ) {
  		require( ABSPATH . WPINC . '/kses.php' );
  		require( ABSPATH . WPINC . '/pluggable.php' );
  		require( ABSPATH . WPINC . '/formatting.php' );
+ 
+ 		$link = wp_guess_url() . '/wp-admin/install.php';
+ 
  		wp_redirect( $link );
  		die();
  	}
***************
*** 552,557 ****
--- 572,582 ----
   * @since 1.2.0
   */
  function shutdown_action_hook() {
+ 	/**
+ 	 * Fires just before PHP shuts down execution.
+ 	 *
+ 	 * @since 1.2.0
+ 	 */
  	do_action( 'shutdown' );
  	wp_cache_close();
  }
diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/media.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/media.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/media.php	2013-08-01 09:49:20.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/media.php	2013-10-22 12:22:11.000000000 -0500
***************
*** 284,291 ****
  		// The larger ratio fits, and is likely to be a more "snug" fit.
  		$ratio = $larger_ratio;
  
! 	$w = intval( $current_width  * $ratio );
! 	$h = intval( $current_height * $ratio );
  
  	// Sometimes, due to rounding, we'll end up with a result like this: 465x700 in a 177x177 box is 117x176... a pixel short
  	// We also have issues with recursive calls resulting in an ever-changing result. Constraining to the result of a constraint should yield the original result.
--- 284,292 ----
  		// The larger ratio fits, and is likely to be a more "snug" fit.
  		$ratio = $larger_ratio;
  
! 	// Very small dimensions may result in 0, 1 should be the minimum.
! 	$w = max ( 1, intval( $current_width  * $ratio ) );
! 	$h = max ( 1, intval( $current_height * $ratio ) );
  
  	// Sometimes, due to rounding, we'll end up with a result like this: 465x700 in a 177x177 box is 117x176... a pixel short
  	// We also have issues with recursive calls resulting in an ever-changing result. Constraining to the result of a constraint should yield the original result.
***************
*** 640,659 ****
  	if ( $output != '' )
  		return $output;
  
! 	extract(shortcode_atts(array(
! 		'id'	=> '',
! 		'align'	=> 'alignnone',
! 		'width'	=> '',
  		'caption' => ''
! 	), $attr, 'caption'));
  
! 	if ( 1 > (int) $width || empty($caption) )
  		return $content;
  
! 	if ( $id ) $id = 'id="' . esc_attr($id) . '" ';
  
! 	return '<div ' . $id . 'class="wp-caption ' . esc_attr($align) . '" style="width: ' . (10 + (int) $width) . 'px">'
! 	. do_shortcode( $content ) . '<p class="wp-caption-text">' . $caption . '</p></div>';
  }
  
  add_shortcode('gallery', 'gallery_shortcode');
--- 641,689 ----
  	if ( $output != '' )
  		return $output;
  
! 	$atts = shortcode_atts( array(
! 		'id'	  => '',
! 		'align'	  => 'alignnone',
! 		'width'	  => '',
  		'caption' => ''
! 	), $attr, 'caption' );
  
! 	$atts['width'] = (int) $atts['width'];
! 	if ( $atts['width'] < 1 || empty( $atts['caption'] ) )
  		return $content;
  
! 	if ( ! empty( $atts['id'] ) )
! 		$atts['id'] = 'id="' . esc_attr( $atts['id'] ) . '" ';
! 
! 	$caption_width = 10 + $atts['width'];
! 
! 	/**
! 	 * Filter the width of an image's caption.
! 	 *
! 	 * By default, the caption is 10 pixels greater than the width of the image,
! 	 * to prevent post content from running up against a floated image.
! 	 *
! 	 * @since 3.7.0
! 	 *
! 	 * @param int $caption_width Width in pixels. To remove this inline style, return zero.
! 	 * @param array $atts {
! 	 *     The attributes of the caption shortcode.
! 	 *
! 	 *     @type string 'id'      The ID of the div element for the caption.
! 	 *     @type string 'align'   The class name that aligns the caption. Default 'alignnone'.
! 	 *     @type int    'width'   The width of the image being captioned.
! 	 *     @type string 'caption' The image's caption.
! 	 * }
! 	 * @param string $content The image element, possibly wrapped in a hyperlink.
! 	 */
! 	$caption_width = apply_filters( 'img_caption_shortcode_width', $caption_width, $atts, $content );
! 
! 	$style = '';
! 	if ( $caption_width )
! 		$style = 'style="width: ' . (int) $caption_width . 'px" ';
  
! 	return '<div ' . $atts['id'] . $style . 'class="wp-caption ' . esc_attr( $atts['align'] ) . '">'
! 	. do_shortcode( $content ) . '<p class="wp-caption-text">' . $atts['caption'] . '</p></div>';
  }
  
  add_shortcode('gallery', 'gallery_shortcode');
***************
*** 704,710 ****
  		'columns'    => 3,
  		'size'       => 'thumbnail',
  		'include'    => '',
! 		'exclude'    => ''
  	), $attr, 'gallery'));
  
  	$id = intval($id);
--- 734,741 ----
  		'columns'    => 3,
  		'size'       => 'thumbnail',
  		'include'    => '',
! 		'exclude'    => '',
! 		'link'       => ''
  	), $attr, 'gallery'));
  
  	$id = intval($id);
***************
*** 778,786 ****
  
  	$i = 0;
  	foreach ( $attachments as $id => $attachment ) {
! 		if ( ! empty( $attr['link'] ) && 'file' === $attr['link'] )
  			$image_output = wp_get_attachment_link( $id, $size, false, false );
! 		elseif ( ! empty( $attr['link'] ) && 'none' === $attr['link'] )
  			$image_output = wp_get_attachment_image( $id, $size, false );
  		else
  			$image_output = wp_get_attachment_link( $id, $size, true, false );
--- 809,817 ----
  
  	$i = 0;
  	foreach ( $attachments as $id => $attachment ) {
! 		if ( ! empty( $link ) && 'file' === $link )
  			$image_output = wp_get_attachment_link( $id, $size, false, false );
! 		elseif ( ! empty( $link ) && 'none' === $link )
  			$image_output = wp_get_attachment_image( $id, $size, false );
  		else
  			$image_output = wp_get_attachment_link( $id, $size, true, false );
***************
*** 844,858 ****
   *
   * @since 3.6.0
   *
!  * @param array $attr Attributes of the shortcode.
   * @return string HTML content to display audio.
   */
! function wp_audio_shortcode( $attr ) {
  	$post_id = get_post() ? get_the_ID() : 0;
  
  	static $instances = 0;
  	$instances++;
  
  	$audio = null;
  
  	$default_types = wp_get_audio_extensions();
--- 875,904 ----
   *
   * @since 3.6.0
   *
!  * @param array  $attr    Attributes of the shortcode.
!  * @param string $content Optional. Shortcode content.
   * @return string HTML content to display audio.
   */
! function wp_audio_shortcode( $attr, $content = '' ) {
  	$post_id = get_post() ? get_the_ID() : 0;
  
  	static $instances = 0;
  	$instances++;
  
+ 	/**
+ 	 * Override the default audio shortcode.
+ 	 *
+ 	 * @since 3.7.0
+ 	 *
+ 	 * @param null              Empty variable to be replaced with shortcode markup.
+ 	 * @param array  $attr      Attributes of the shortcode.
+ 	 * @param string $content   Shortcode content.
+ 	 * @param int    $instances Unique numeric ID of this audio shortcode instance.
+ 	 */
+ 	$html = apply_filters( 'wp_audio_shortcode_override', '', $attr, $content, $instances );
+ 	if ( '' !== $html )
+ 		return $html;
+ 
  	$audio = null;
  
  	$default_types = wp_get_audio_extensions();
***************
*** 871,877 ****
  	$primary = false;
  	if ( ! empty( $src ) ) {
  		$type = wp_check_filetype( $src, wp_get_mime_types() );
! 		if ( ! in_array( $type['ext'], $default_types ) )
  			return sprintf( '<a class="wp-embedded-audio" href="%s">%s</a>', esc_url( $src ), esc_html( $src ) );
  		$primary = true;
  		array_unshift( $default_types, 'src' );
--- 917,923 ----
  	$primary = false;
  	if ( ! empty( $src ) ) {
  		$type = wp_check_filetype( $src, wp_get_mime_types() );
! 		if ( ! in_array( strtolower( $type['ext'] ), $default_types ) )
  			return sprintf( '<a class="wp-embedded-audio" href="%s">%s</a>', esc_url( $src ), esc_html( $src ) );
  		$primary = true;
  		array_unshift( $default_types, 'src' );
***************
*** 879,885 ****
  		foreach ( $default_types as $ext ) {
  			if ( ! empty( $$ext ) ) {
  				$type = wp_check_filetype( $$ext, wp_get_mime_types() );
! 				if ( $type['ext'] === $ext )
  					$primary = true;
  			}
  		}
--- 925,931 ----
  		foreach ( $default_types as $ext ) {
  			if ( ! empty( $$ext ) ) {
  				$type = wp_check_filetype( $$ext, wp_get_mime_types() );
! 				if ( strtolower( $type['ext'] ) === $ext )
  					$primary = true;
  			}
  		}
***************
*** 946,952 ****
  
  	return apply_filters( 'wp_audio_shortcode', $html, $atts, $audio, $post_id, $library );
  }
! add_shortcode( 'audio', apply_filters( 'wp_audio_shortcode_handler', 'wp_audio_shortcode' ) );
  
  /**
   * Return a filtered list of WP-supported video formats
--- 992,998 ----
  
  	return apply_filters( 'wp_audio_shortcode', $html, $atts, $audio, $post_id, $library );
  }
! add_shortcode( 'audio', 'wp_audio_shortcode' );
  
  /**
   * Return a filtered list of WP-supported video formats
***************
*** 966,981 ****
   *
   * @since 3.6.0
   *
!  * @param array $attr Attributes of the shortcode.
   * @return string HTML content to display video.
   */
! function wp_video_shortcode( $attr ) {
  	global $content_width;
  	$post_id = get_post() ? get_the_ID() : 0;
  
  	static $instances = 0;
  	$instances++;
  
  	$video = null;
  
  	$default_types = wp_get_video_extensions();
--- 1012,1042 ----
   *
   * @since 3.6.0
   *
!  * @param array  $attr    Attributes of the shortcode.
!  * @param string $content Optional. Shortcode content.
   * @return string HTML content to display video.
   */
! function wp_video_shortcode( $attr, $content = '' ) {
  	global $content_width;
  	$post_id = get_post() ? get_the_ID() : 0;
  
  	static $instances = 0;
  	$instances++;
  
+ 	/**
+ 	 * Override the default video shortcode.
+ 	 *
+ 	 * @since 3.7.0
+ 	 *
+ 	 * @param null              Empty variable to be replaced with shortcode markup.
+ 	 * @param array  $attr      Attributes of the shortcode.
+ 	 * @param string $content   Shortcode content.
+ 	 * @param int    $instances Unique numeric ID of this video shortcode instance.
+ 	 */
+ 	$html = apply_filters( 'wp_video_shortcode_override', '', $attr, $content, $instances );
+ 	if ( '' !== $html )
+ 		return $html;
+ 
  	$video = null;
  
  	$default_types = wp_get_video_extensions();
***************
*** 1010,1016 ****
  	$primary = false;
  	if ( ! empty( $src ) ) {
  		$type = wp_check_filetype( $src, wp_get_mime_types() );
! 		if ( ! in_array( $type['ext'], $default_types ) )
  			return sprintf( '<a class="wp-embedded-video" href="%s">%s</a>', esc_url( $src ), esc_html( $src ) );
  		$primary = true;
  		array_unshift( $default_types, 'src' );
--- 1071,1077 ----
  	$primary = false;
  	if ( ! empty( $src ) ) {
  		$type = wp_check_filetype( $src, wp_get_mime_types() );
! 		if ( ! in_array( strtolower( $type['ext'] ), $default_types ) )
  			return sprintf( '<a class="wp-embedded-video" href="%s">%s</a>', esc_url( $src ), esc_html( $src ) );
  		$primary = true;
  		array_unshift( $default_types, 'src' );
***************
*** 1018,1024 ****
  		foreach ( $default_types as $ext ) {
  			if ( ! empty( $$ext ) ) {
  				$type = wp_check_filetype( $$ext, wp_get_mime_types() );
! 				if ( $type['ext'] === $ext )
  					$primary = true;
  			}
  		}
--- 1079,1085 ----
  		foreach ( $default_types as $ext ) {
  			if ( ! empty( $$ext ) ) {
  				$type = wp_check_filetype( $$ext, wp_get_mime_types() );
! 				if ( strtolower( $type['ext'] ) === $ext )
  					$primary = true;
  			}
  		}
***************
*** 1090,1096 ****
  	$html = sprintf( '<div style="width: %dpx; max-width: 100%%;">%s</div>', $width, $html );
  	return apply_filters( 'wp_video_shortcode', $html, $atts, $video, $post_id, $library );
  }
! add_shortcode( 'video', apply_filters( 'wp_video_shortcode_handler', 'wp_video_shortcode' ) );
  
  /**
   * Display previous image link that has the same post parent.
--- 1151,1157 ----
  	$html = sprintf( '<div style="width: %dpx; max-width: 100%%;">%s</div>', $width, $html );
  	return apply_filters( 'wp_video_shortcode', $html, $atts, $video, $post_id, $library );
  }
! add_shortcode( 'video', 'wp_video_shortcode' );
  
  /**
   * Display previous image link that has the same post parent.
***************
*** 1683,1688 ****
--- 1744,1750 ----
  
  	if ( $meta && 'image' === $type ) {
  		$sizes = array();
+ 		/** This filter is documented in wp-admin/includes/media.php */
  		$possible_sizes = apply_filters( 'image_size_names_choose', array(
  			'thumbnail' => __('Thumbnail'),
  			'medium'    => __('Medium'),
diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/media-template.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/media-template.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/media-template.php	2013-07-23 12:29:55.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/media-template.php	2013-10-22 12:22:11.000000000 -0500
***************
*** 341,346 ****
--- 341,347 ----
  					<# } #>>
  					<?php
  
+ 					/** This filter is documented in wp-admin/includes/media.php */
  					$sizes = apply_filters( 'image_size_names_choose', array(
  						'thumbnail' => __('Thumbnail'),
  						'medium'    => __('Medium'),
diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/meta.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/meta.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/meta.php	2013-07-16 09:21:05.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/meta.php	2013-09-23 15:31:09.000000000 -0500
***************
*** 22,28 ****
   * @param string $meta_type Type of object metadata is for (e.g., comment, post, or user)
   * @param int $object_id ID of the object metadata is for
   * @param string $meta_key Metadata key
!  * @param string $meta_value Metadata value
   * @param bool $unique Optional, default is false. Whether the specified metadata key should be
   * 		unique for the object. If true, and the object already has a value for the specified
   * 		metadata key, no change will be made
--- 22,28 ----
   * @param string $meta_type Type of object metadata is for (e.g., comment, post, or user)
   * @param int $object_id ID of the object metadata is for
   * @param string $meta_key Metadata key
!  * @param mixed $meta_value Metadata value. Must be serializable if non-scalar.
   * @param bool $unique Optional, default is false. Whether the specified metadata key should be
   * 		unique for the object. If true, and the object already has a value for the specified
   * 		metadata key, no change will be made
***************
*** 93,100 ****
   * @param string $meta_type Type of object metadata is for (e.g., comment, post, or user)
   * @param int $object_id ID of the object metadata is for
   * @param string $meta_key Metadata key
!  * @param string $meta_value Metadata value
!  * @param string $prev_value Optional. If specified, only update existing metadata entries with
   * 		the specified value. Otherwise, update all entries.
   * @return bool True on successful update, false on failure.
   */
--- 93,100 ----
   * @param string $meta_type Type of object metadata is for (e.g., comment, post, or user)
   * @param int $object_id ID of the object metadata is for
   * @param string $meta_key Metadata key
!  * @param mixed $meta_value Metadata value. Must be serializable if non-scalar.
!  * @param mixed $prev_value Optional. If specified, only update existing metadata entries with
   * 		the specified value. Otherwise, update all entries.
   * @return bool True on successful update, false on failure.
   */
***************
*** 151,157 ****
  	if ( 'post' == $meta_type )
  		do_action( 'update_postmeta', $meta_id, $object_id, $meta_key, $meta_value );
  
! 	$wpdb->update( $table, $data, $where );
  
  	wp_cache_delete($object_id, $meta_type . '_meta');
  
--- 151,159 ----
  	if ( 'post' == $meta_type )
  		do_action( 'update_postmeta', $meta_id, $object_id, $meta_key, $meta_value );
  
! 	$result = $wpdb->update( $table, $data, $where );
! 	if ( ! $result )
! 		return false;
  
  	wp_cache_delete($object_id, $meta_type . '_meta');
  
***************
*** 174,180 ****
   * @param string $meta_type Type of object metadata is for (e.g., comment, post, or user)
   * @param int $object_id ID of the object metadata is for
   * @param string $meta_key Metadata key
!  * @param string $meta_value Optional. Metadata value. If specified, only delete metadata entries
   * 		with this value. Otherwise, delete all entries with the specified meta_key.
   * @param bool $delete_all Optional, default is false. If true, delete matching metadata entries
   * 		for all objects, ignoring the specified object_id. Otherwise, only delete matching
--- 176,182 ----
   * @param string $meta_type Type of object metadata is for (e.g., comment, post, or user)
   * @param int $object_id ID of the object metadata is for
   * @param string $meta_key Metadata key
!  * @param mixed $meta_value Optional. Metadata value. Must be serializable if non-scalar. If specified, only delete metadata entries
   * 		with this value. Otherwise, delete all entries with the specified meta_key.
   * @param bool $delete_all Optional, default is false. If true, delete matching metadata entries
   * 		for all objects, ignoring the specified object_id. Otherwise, only delete matching
***************
*** 435,441 ****
  			do_action( 'update_postmeta', $meta_id, $object_id, $meta_key, $meta_value );
  
  		// Run the update query, all fields in $data are %s, $where is a %d.
! 		$result = (bool) $wpdb->update( $table, $data, $where, '%s', '%d' );
  
  		// Clear the caches.
  		wp_cache_delete($object_id, $meta_type . '_meta');
--- 437,445 ----
  			do_action( 'update_postmeta', $meta_id, $object_id, $meta_key, $meta_value );
  
  		// Run the update query, all fields in $data are %s, $where is a %d.
! 		$result = $wpdb->update( $table, $data, $where, '%s', '%d' );
! 		if ( ! $result )
! 			return false;
  
  		// Clear the caches.
  		wp_cache_delete($object_id, $meta_type . '_meta');
***************
*** 445,451 ****
  		if ( 'post' == $meta_type )
  			do_action( 'updated_postmeta', $meta_id, $object_id, $meta_key, $meta_value );
  
! 		return $result;
  	}
  
  	// And if the meta was not found.
--- 449,455 ----
  		if ( 'post' == $meta_type )
  			do_action( 'updated_postmeta', $meta_id, $object_id, $meta_key, $meta_value );
  
! 		return true;
  	}
  
  	// And if the meta was not found.
***************
*** 614,620 ****
  	* - 'key' string The meta key
  	* - 'value' string|array The meta value
  	* - 'compare' (optional) string How to compare the key to the value.
! 	*              Possible values: '=', '!=', '>', '>=', '<', '<=', 'LIKE', 'NOT LIKE', 'IN', 'NOT IN', 'BETWEEN', 'NOT BETWEEN'.
  	*              Default: '='
  	* - 'type' string (optional) The type of the value.
  	*              Possible values: 'NUMERIC', 'BINARY', 'CHAR', 'DATE', 'DATETIME', 'DECIMAL', 'SIGNED', 'TIME', 'UNSIGNED'.
--- 618,625 ----
  	* - 'key' string The meta key
  	* - 'value' string|array The meta value
  	* - 'compare' (optional) string How to compare the key to the value.
! 	*              Possible values: '=', '!=', '>', '>=', '<', '<=', 'LIKE', 'NOT LIKE', 'IN', 'NOT IN',
! 	*              'BETWEEN', 'NOT BETWEEN', 'REGEXP', 'NOT REGEXP', 'RLIKE'.
  	*              Default: '='
  	* - 'type' string (optional) The type of the value.
  	*              Possible values: 'NUMERIC', 'BINARY', 'CHAR', 'DATE', 'DATETIME', 'DECIMAL', 'SIGNED', 'TIME', 'UNSIGNED'.
***************
*** 689,694 ****
--- 694,722 ----
  	}
  
  	/**
+ 	 * Given a meta type, return the appropriate alias if applicable
+ 	 *
+ 	 * @since 3.7.0
+ 	 *
+ 	 * @param string $type MySQL type to cast meta_value
+ 	 * @return string MySQL type
+ 	 */
+ 	function get_cast_for_type( $type = '' ) {
+ 		if ( empty( $type ) )
+ 			return 'CHAR';
+ 
+ 		$meta_type = strtoupper( $type );
+ 
+ 		if ( ! in_array( $meta_type, array( 'BINARY', 'CHAR', 'DATE', 'DATETIME', 'DECIMAL', 'SIGNED', 'TIME', 'UNSIGNED', 'NUMERIC' ) ) )
+ 			return 'CHAR';
+ 
+ 		if ( 'NUMERIC' == $meta_type )
+ 			$meta_type = 'SIGNED';
+ 
+ 		return $meta_type;
+ 	}
+ 
+ 	/**
  	 * Generates SQL clauses to be appended to a main query.
  	 *
  	 * @since 3.2.0
***************
*** 720,727 ****
  				$key_only_queries[$k] = $q;
  				unset( $this->queries[$k] );
  			}
! 		}		
! 		
  		// Split out the meta_key only queries (we can only do this for OR)
  		if ( 'OR' == $this->relation ) {
  			foreach ( $this->queries as $k => $q ) {
--- 748,755 ----
  				$key_only_queries[$k] = $q;
  				unset( $this->queries[$k] );
  			}
! 		}
! 
  		// Split out the meta_key only queries (we can only do this for OR)
  		if ( 'OR' == $this->relation ) {
  			foreach ( $this->queries as $k => $q ) {
***************
*** 744,755 ****
  
  		foreach ( $queries as $k => $q ) {
  			$meta_key = isset( $q['key'] ) ? trim( $q['key'] ) : '';
! 			$meta_type = isset( $q['type'] ) ? strtoupper( $q['type'] ) : 'CHAR';
! 
! 			if ( 'NUMERIC' == $meta_type )
! 				$meta_type = 'SIGNED';
! 			elseif ( ! in_array( $meta_type, array( 'BINARY', 'CHAR', 'DATE', 'DATETIME', 'DECIMAL', 'SIGNED', 'TIME', 'UNSIGNED' ) ) )
! 				$meta_type = 'CHAR';
  
  			$meta_value = isset( $q['value'] ) ? $q['value'] : null;
  
--- 772,778 ----
  
  		foreach ( $queries as $k => $q ) {
  			$meta_key = isset( $q['key'] ) ? trim( $q['key'] ) : '';
! 			$meta_type = $this->get_cast_for_type( isset( $q['type'] ) ? $q['type'] : '' );
  
  			$meta_value = isset( $q['value'] ) ? $q['value'] : null;
  
***************
*** 763,769 ****
  				'LIKE', 'NOT LIKE',
  				'IN', 'NOT IN',
  				'BETWEEN', 'NOT BETWEEN',
! 				'NOT EXISTS'
  			) ) )
  				$meta_compare = '=';
  
--- 786,793 ----
  				'LIKE', 'NOT LIKE',
  				'IN', 'NOT IN',
  				'BETWEEN', 'NOT BETWEEN',
! 				'NOT EXISTS',
! 				'REGEXP', 'NOT REGEXP', 'RLIKE'
  			) ) )
  				$meta_compare = '=';
  
diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/ms-blogs.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/ms-blogs.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/ms-blogs.php	2013-04-29 07:49:33.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/ms-blogs.php	2013-09-24 18:41:10.000000000 -0500
***************
*** 56,87 ****
  }
  
  /**
-  * Get a full blog URL, given a domain and a path.
-  *
-  * @since MU
-  *
-  * @param string $domain
-  * @param string $path
-  * @return string
-  */
- function get_blogaddress_by_domain( $domain, $path ) {
- 	if ( is_subdomain_install() ) {
- 		$url = "http://" . $domain.$path;
- 	} else {
- 		if ( $domain != $_SERVER['HTTP_HOST'] ) {
- 			$blogname = substr( $domain, 0, strpos( $domain, '.' ) );
- 			$url = 'http://' . substr( $domain, strpos( $domain, '.' ) + 1 ) . $path;
- 			// we're not installing the main blog
- 			if ( $blogname != 'www.' )
- 				$url .= $blogname . '/';
- 		} else { // main blog
- 			$url = 'http://' . $domain . $path;
- 		}
- 	}
- 	return esc_url( $url );
- }
- 
- /**
   * Given a blog's (subdomain or directory) slug, retrieve its id.
   *
   * @since MU
--- 56,61 ----
***************
*** 524,530 ****
  	}
  
  	$wpdb->set_blog_id( $new_blog );
! 	$GLOBALS['table_prefix'] = $wpdb->prefix;
  	$prev_blog_id = $GLOBALS['blog_id'];
  	$GLOBALS['blog_id'] = $new_blog;
  
--- 498,504 ----
  	}
  
  	$wpdb->set_blog_id( $new_blog );
! 	$GLOBALS['table_prefix'] = $wpdb->get_blog_prefix();
  	$prev_blog_id = $GLOBALS['blog_id'];
  	$GLOBALS['blog_id'] = $new_blog;
  
***************
*** 587,593 ****
  	$wpdb->set_blog_id( $blog );
  	$prev_blog_id = $GLOBALS['blog_id'];
  	$GLOBALS['blog_id'] = $blog;
! 	$GLOBALS['table_prefix'] = $wpdb->prefix;
  
  	if ( function_exists( 'wp_cache_switch_to_blog' ) ) {
  		wp_cache_switch_to_blog( $blog );
--- 561,567 ----
  	$wpdb->set_blog_id( $blog );
  	$prev_blog_id = $GLOBALS['blog_id'];
  	$GLOBALS['blog_id'] = $blog;
! 	$GLOBALS['table_prefix'] = $wpdb->get_blog_prefix();
  
  	if ( function_exists( 'wp_cache_switch_to_blog' ) ) {
  		wp_cache_switch_to_blog( $blog );
